Linux Audio

Check our new training course

Loading...
v4.10.11
  1#!/bin/sh
 
  2#
  3# link vmlinux
  4#
  5# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
  6# $(KBUILD_VMLINUX_MAIN). Most are built-in.o files from top-level directories
  7# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
  8# Ordering when linking is important, and $(KBUILD_VMLINUX_INIT) must be first.
  9#
 10# vmlinux
 11#   ^
 12#   |
 13#   +-< $(KBUILD_VMLINUX_INIT)
 14#   |   +--< init/version.o + more
 15#   |
 16#   +--< $(KBUILD_VMLINUX_MAIN)
 17#   |    +--< drivers/built-in.o mm/built-in.o + more
 18#   |
 19#   +-< ${kallsymso} (see description in KALLSYMS section)
 20#
 21# vmlinux version (uname -v) cannot be updated during normal
 22# descending-into-subdirs phase since we do not yet know if we need to
 23# update vmlinux.
 24# Therefore this step is delayed until just before final link of vmlinux.
 25#
 26# System.map is generated to document addresses of all kernel symbols
 27
 28# Error out on error
 29set -e
 30
 
 
 
 
 
 
 
 
 31# Nice output in kbuild format
 32# Will be supressed by "make -s"
 33info()
 34{
 35	if [ "${quiet}" != "silent_" ]; then
 36		printf "  %-7s %s\n" ${1} ${2}
 37	fi
 38}
 39
 40# Thin archive build here makes a final archive with
 41# symbol table and indexes from vmlinux objects, which can be
 42# used as input to linker.
 43#
 44# Traditional incremental style of link does not require this step
 45#
 46# built-in.o output file
 47#
 48archive_builtin()
 49{
 50	if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
 51		info AR built-in.o
 52		rm -f built-in.o;
 53		${AR} rcsT${KBUILD_ARFLAGS} built-in.o			\
 54					${KBUILD_VMLINUX_INIT}		\
 55					${KBUILD_VMLINUX_MAIN}
 
 
 
 
 
 
 
 
 
 
 
 
 
 56	fi
 57}
 58
 59# Link of vmlinux.o used for section mismatch analysis
 60# ${1} output file
 61modpost_link()
 62{
 63	local objects
 64
 65	if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
 66		objects="--whole-archive built-in.o"
 
 
 
 
 
 67	else
 68		objects="${KBUILD_VMLINUX_INIT}				\
 69			--start-group					\
 70			${KBUILD_VMLINUX_MAIN}				\
 71			--end-group"
 72	fi
 73	${LD} ${LDFLAGS} -r -o ${1} ${objects}
 74}
 75
 76# Link of vmlinux
 77# ${1} - optional extra .o files
 78# ${2} - output file
 79vmlinux_link()
 80{
 81	local lds="${objtree}/${KBUILD_LDS}"
 82	local objects
 83
 84	if [ "${SRCARCH}" != "um" ]; then
 85		if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
 86			objects="--whole-archive built-in.o ${1}"
 87		else
 88			objects="${KBUILD_VMLINUX_INIT}			\
 89				--start-group				\
 90				${KBUILD_VMLINUX_MAIN}			\
 91				--end-group				\
 92				${1}"
 93		fi
 94
 95		${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2}		\
 96			-T ${lds} ${objects}
 97	else
 98		if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
 99			objects="-Wl,--whole-archive built-in.o ${1}"
100		else
101			objects="${KBUILD_VMLINUX_INIT}			\
102				-Wl,--start-group			\
103				${KBUILD_VMLINUX_MAIN}			\
104				-Wl,--end-group				\
105				${1}"
106		fi
107
108		${CC} ${CFLAGS_vmlinux} -o ${2}				\
109			-Wl,-T,${lds}					\
110			${objects}					\
111			-lutil -lrt -lpthread
112		rm -f linux
113	fi
 
 
 
 
 
114}
115
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
116
117# Create ${2} .o file with all symbols from the ${1} object file
118kallsyms()
119{
120	info KSYM ${2}
121	local kallsymopt;
122
123	if [ -n "${CONFIG_HAVE_UNDERSCORE_SYMBOL_PREFIX}" ]; then
124		kallsymopt="${kallsymopt} --symbol-prefix=_"
125	fi
126
127	if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
128		kallsymopt="${kallsymopt} --all-symbols"
129	fi
130
131	if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
132		kallsymopt="${kallsymopt} --absolute-percpu"
133	fi
134
135	if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
136		kallsymopt="${kallsymopt} --base-relative"
137	fi
138
139	local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL}               \
140		      ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
 
141
142	local afile="`basename ${2} .o`.S"
 
 
143
144	${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
145	${CC} ${aflags} -c -o ${2} ${afile}
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
146}
147
148# Create map file with all symbols from ${1}
149# See mksymap for additional details
150mksysmap()
151{
 
152	${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
153}
154
155sortextable()
156{
157	${objtree}/scripts/sortextable ${1}
158}
159
160# Delete output files in case of error
161cleanup()
162{
163	rm -f .old_version
164	rm -f .tmp_System.map
165	rm -f .tmp_kallsyms*
166	rm -f .tmp_version
167	rm -f .tmp_vmlinux*
168	rm -f built-in.o
169	rm -f System.map
170	rm -f vmlinux
171	rm -f vmlinux.o
172}
173
174on_exit()
175{
176	if [ $? -ne 0 ]; then
177		cleanup
178	fi
179}
180trap on_exit EXIT
181
182on_signals()
183{
184	exit 1
185}
186trap on_signals HUP INT QUIT TERM
187
188#
189#
190# Use "make V=1" to debug this script
191case "${KBUILD_VERBOSE}" in
192*1*)
193	set -x
194	;;
195esac
196
197if [ "$1" = "clean" ]; then
198	cleanup
199	exit 0
200fi
201
202# We need access to CONFIG_ symbols
203case "${KCONFIG_CONFIG}" in
204*/*)
205	. "${KCONFIG_CONFIG}"
206	;;
207*)
208	# Force using a file from the current directory
209	. "./${KCONFIG_CONFIG}"
210esac
211
212# Update version
213info GEN .version
214if [ ! -r .version ]; then
215	rm -f .version;
216	echo 1 >.version;
217else
218	mv .version .old_version;
219	expr 0$(cat .old_version) + 1 >.version;
220fi;
221
222# final build of init/
223${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init GCC_PLUGINS_CFLAGS="${GCC_PLUGINS_CFLAGS}"
224
225archive_builtin
226
227#link vmlinux.o
228info LD vmlinux.o
229modpost_link vmlinux.o
230
231# modpost vmlinux.o to check for section mismatches
232${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
 
 
 
 
 
 
 
233
234kallsymso=""
 
235kallsyms_vmlinux=""
236if [ -n "${CONFIG_KALLSYMS}" ]; then
237
238	# kallsyms support
239	# Generate section listing all symbols and add it into vmlinux
240	# It's a three step process:
241	# 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
242	#     but __kallsyms is empty.
243	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
244	#     the right size
245	# 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
246	#     the right size, but due to the added section, some
247	#     addresses have shifted.
248	#     From here, we generate a correct .tmp_kallsyms2.o
249	# 3)  That link may have expanded the kernel image enough that
250	#     more linker branch stubs / trampolines had to be added, which
251	#     introduces new names, which further expands kallsyms. Do another
252	#     pass if that is the case. In theory it's possible this results
253	#     in even more stubs, but unlikely.
254	#     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
255	#     other bugs.
256	# 4)  The correct ${kallsymso} is linked into the final vmlinux.
257	#
258	# a)  Verify that the System.map from vmlinux matches the map from
259	#     ${kallsymso}.
260
261	kallsymso=.tmp_kallsyms2.o
262	kallsyms_vmlinux=.tmp_vmlinux2
263
264	# step 1
265	vmlinux_link "" .tmp_vmlinux1
266	kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
267
268	# step 2
269	vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
270	kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
271
272	# step 3
273	size1=$(stat -c "%s" .tmp_kallsyms1.o)
274	size2=$(stat -c "%s" .tmp_kallsyms2.o)
275
276	if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
277		kallsymso=.tmp_kallsyms3.o
278		kallsyms_vmlinux=.tmp_vmlinux3
279
280		vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
281
282		kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
283	fi
284fi
285
286info LD vmlinux
287vmlinux_link "${kallsymso}" vmlinux
288
289if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
290	info SORTEX vmlinux
291	sortextable vmlinux
 
292fi
293
294info SYSMAP System.map
295mksysmap vmlinux System.map
296
297# step a (see comment above)
298if [ -n "${CONFIG_KALLSYMS}" ]; then
299	mksysmap ${kallsyms_vmlinux} .tmp_System.map
 
 
 
 
300
301	if ! cmp -s System.map .tmp_System.map; then
 
 
302		echo >&2 Inconsistent kallsyms data
303		echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
304		exit 1
305	fi
306fi
307
308# We made a new kernel - delete old version file
309rm -f .old_version
v6.2
  1#!/bin/sh
  2# SPDX-License-Identifier: GPL-2.0
  3#
  4# link vmlinux
  5#
  6# vmlinux is linked from the objects in vmlinux.a and $(KBUILD_VMLINUX_LIBS).
  7# vmlinux.a contains objects that are linked unconditionally.
  8# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
  9# (not within --whole-archive), and do not require symbol indexes added.
 10#
 11# vmlinux
 12#   ^
 13#   |
 14#   +--< vmlinux.a
 
 15#   |
 16#   +--< $(KBUILD_VMLINUX_LIBS)
 17#   |    +--< lib/lib.a + more
 18#   |
 19#   +-< ${kallsymso} (see description in KALLSYMS section)
 20#
 21# vmlinux version (uname -v) cannot be updated during normal
 22# descending-into-subdirs phase since we do not yet know if we need to
 23# update vmlinux.
 24# Therefore this step is delayed until just before final link of vmlinux.
 25#
 26# System.map is generated to document addresses of all kernel symbols
 27
 28# Error out on error
 29set -e
 30
 31LD="$1"
 32KBUILD_LDFLAGS="$2"
 33LDFLAGS_vmlinux="$3"
 34
 35is_enabled() {
 36	grep -q "^$1=y" include/config/auto.conf
 37}
 38
 39# Nice output in kbuild format
 40# Will be supressed by "make -s"
 41info()
 42{
 43	printf "  %-7s %s\n" "${1}" "${2}"
 
 
 44}
 45
 46# Link of vmlinux
 47# ${1} - output file
 48# ${2}, ${3}, ... - optional extra .o files
 49vmlinux_link()
 
 
 
 
 
 50{
 51	local output=${1}
 52	local objs
 53	local libs
 54	local ld
 55	local ldflags
 56	local ldlibs
 57
 58	info LD ${output}
 59
 60	# skip output file argument
 61	shift
 62
 63	if is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT; then
 64		# Use vmlinux.o instead of performing the slow LTO link again.
 65		objs=vmlinux.o
 66		libs=
 67	else
 68		objs=vmlinux.a
 69		libs="${KBUILD_VMLINUX_LIBS}"
 70	fi
 
 71
 72	if is_enabled CONFIG_MODULES; then
 73		objs="${objs} .vmlinux.export.o"
 74	fi
 
 
 75
 76	objs="${objs} init/version-timestamp.o"
 77
 78	if [ "${SRCARCH}" = "um" ]; then
 79		wl=-Wl,
 80		ld="${CC}"
 81		ldflags="${CFLAGS_vmlinux}"
 82		ldlibs="-lutil -lrt -lpthread"
 83	else
 84		wl=
 85		ld="${LD}"
 86		ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
 87		ldlibs=
 88	fi
 
 
 89
 90	ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
 
 
 
 
 
 
 91
 92	# The kallsyms linking does not need debug symbols included.
 93	if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
 94		ldflags="${ldflags} ${wl}--strip-debug"
 95	fi
 
 
 
 
 
 
 96
 97	if is_enabled CONFIG_VMLINUX_MAP; then
 98		ldflags="${ldflags} ${wl}-Map=${output}.map"
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 99	fi
100
101	${ld} ${ldflags} -o ${output}					\
102		${wl}--whole-archive ${objs} ${wl}--no-whole-archive	\
103		${wl}--start-group ${libs} ${wl}--end-group		\
104		$@ ${ldlibs}
105}
106
107# generate .BTF typeinfo from DWARF debuginfo
108# ${1} - vmlinux image
109# ${2} - file to dump raw BTF data into
110gen_btf()
111{
112	local pahole_ver
113
114	if ! [ -x "$(command -v ${PAHOLE})" ]; then
115		echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
116		return 1
117	fi
118
119	pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
120	if [ "${pahole_ver}" -lt "116" ]; then
121		echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
122		return 1
123	fi
124
125	vmlinux_link ${1}
126
127	info "BTF" ${2}
128	LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
129
130	# Create ${2} which contains just .BTF section but no symbols. Add
131	# SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
132	# deletes all symbols including __start_BTF and __stop_BTF, which will
133	# be redefined in the linker script. Add 2>/dev/null to suppress GNU
134	# objcopy warnings: "empty loadable segment detected at ..."
135	${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
136		--strip-all ${1} ${2} 2>/dev/null
137	# Change e_type to ET_REL so that it can be used to link final vmlinux.
138	# Unlike GNU ld, lld does not allow an ET_EXEC input.
139	printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
140}
141
142# Create ${2} .S file with all symbols from the ${1} object file
143kallsyms()
144{
 
145	local kallsymopt;
146
147	if is_enabled CONFIG_KALLSYMS_ALL; then
 
 
 
 
148		kallsymopt="${kallsymopt} --all-symbols"
149	fi
150
151	if is_enabled CONFIG_KALLSYMS_ABSOLUTE_PERCPU; then
152		kallsymopt="${kallsymopt} --absolute-percpu"
153	fi
154
155	if is_enabled CONFIG_KALLSYMS_BASE_RELATIVE; then
156		kallsymopt="${kallsymopt} --base-relative"
157	fi
158
159	if is_enabled CONFIG_LTO_CLANG; then
160		kallsymopt="${kallsymopt} --lto-clang"
161	fi
162
163	info KSYMS ${2}
164	scripts/kallsyms ${kallsymopt} ${1} > ${2}
165}
166
167# Perform one step in kallsyms generation, including temporary linking of
168# vmlinux.
169kallsyms_step()
170{
171	kallsymso_prev=${kallsymso}
172	kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
173	kallsymso=${kallsyms_vmlinux}.o
174	kallsyms_S=${kallsyms_vmlinux}.S
175
176	vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
177	mksysmap ${kallsyms_vmlinux} ${kallsyms_vmlinux}.syms
178	kallsyms ${kallsyms_vmlinux}.syms ${kallsyms_S}
179
180	info AS ${kallsyms_S}
181	${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
182	      ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
183	      -c -o ${kallsymso} ${kallsyms_S}
184}
185
186# Create map file with all symbols from ${1}
187# See mksymap for additional details
188mksysmap()
189{
190	info NM ${2}
191	${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
192}
193
194sorttable()
195{
196	${objtree}/scripts/sorttable ${1}
197}
198
199# Delete output files in case of error
200cleanup()
201{
202	rm -f .btf.*
 
 
 
 
 
203	rm -f System.map
204	rm -f vmlinux
205	rm -f vmlinux.map
 
 
 
 
 
 
 
206}
 
207
 
 
 
 
 
 
 
 
208# Use "make V=1" to debug this script
209case "${KBUILD_VERBOSE}" in
210*1*)
211	set -x
212	;;
213esac
214
215if [ "$1" = "clean" ]; then
216	cleanup
217	exit 0
218fi
219
220${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init init/version-timestamp.o
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
221
222btf_vmlinux_bin_o=""
223if is_enabled CONFIG_DEBUG_INFO_BTF; then
224	btf_vmlinux_bin_o=.btf.vmlinux.bin.o
225	if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
226		echo >&2 "Failed to generate BTF for vmlinux"
227		echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
228		exit 1
229	fi
230fi
231
232kallsymso=""
233kallsymso_prev=""
234kallsyms_vmlinux=""
235if is_enabled CONFIG_KALLSYMS; then
236
237	# kallsyms support
238	# Generate section listing all symbols and add it into vmlinux
239	# It's a three step process:
240	# 1)  Link .tmp_vmlinux.kallsyms1 so it has all symbols and sections,
241	#     but __kallsyms is empty.
242	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
243	#     the right size
244	# 2)  Link .tmp_vmlinux.kallsyms2 so it now has a __kallsyms section of
245	#     the right size, but due to the added section, some
246	#     addresses have shifted.
247	#     From here, we generate a correct .tmp_vmlinux.kallsyms2.o
248	# 3)  That link may have expanded the kernel image enough that
249	#     more linker branch stubs / trampolines had to be added, which
250	#     introduces new names, which further expands kallsyms. Do another
251	#     pass if that is the case. In theory it's possible this results
252	#     in even more stubs, but unlikely.
253	#     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
254	#     other bugs.
255	# 4)  The correct ${kallsymso} is linked into the final vmlinux.
256	#
257	# a)  Verify that the System.map from vmlinux matches the map from
258	#     ${kallsymso}.
259
260	kallsyms_step 1
261	kallsyms_step 2
 
 
 
 
 
 
 
 
262
263	# step 3
264	size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
265	size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
266
267	if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
268		kallsyms_step 3
 
 
 
 
 
269	fi
270fi
271
272vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
 
273
274# fill in BTF IDs
275if is_enabled CONFIG_DEBUG_INFO_BTF && is_enabled CONFIG_BPF; then
276	info BTFIDS vmlinux
277	${RESOLVE_BTFIDS} vmlinux
278fi
279
 
280mksysmap vmlinux System.map
281
282if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
283	info SORTTAB vmlinux
284	if ! sorttable vmlinux; then
285		echo >&2 Failed to sort kernel tables
286		exit 1
287	fi
288fi
289
290# step a (see comment above)
291if is_enabled CONFIG_KALLSYMS; then
292	if ! cmp -s System.map ${kallsyms_vmlinux}.syms; then
293		echo >&2 Inconsistent kallsyms data
294		echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
295		exit 1
296	fi
297fi
298
299# For fixdep
300echo "vmlinux: $0" > .vmlinux.d